//NRF14L01+      TXD
#include <stm32f10x.h>
#include <stdio.h>
#include <delay.h>
#include <nrf24l01.h>

#define KEY0 GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_5)

//Զ庯
void usart_init(void);
void KeyLed_init(void);
void PeriphClock(void);
void key(void);

int fputc(int ch,FILE *f)
{
	USART_SendData(USART1,(u8)ch);
	while(USART_GetFlagStatus(USART1,USART_FLAG_TC)==RESET);
	return ch;
}

u8 key0flag=0,key_sendflag=0;//־λ ͱ־λ 
u8 SendBuf[32]={0x30,0x31,0x32,0x33,0x34};//һ32Byteķͻ

int main(void)
{
	u8 nrfsend_flag;//ͻӦ־λ
	
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	PeriphClock();//ʱ
	delay_init(); //ʱʼ
	usart_init(); //ڳʼ
	KeyLed_init();//ʾƳʼ
	
	nrf24l01_init();//NRF24L01ʼ
	if(nrf24l01_Cheak()==1)//NRF24L01Ƿ-ģʽǰ-ģʽ
	{
	  printf("NRF24L01_OK\n");
	}
	else 
	{
		printf("NRF24L01_NO\n");
	}
	NRF24L01_Tx_Mode();//óɷģʽ
	while(1)
	{
    key();
		if(key_sendflag)
		{
			key_sendflag=0;  
			nrfsend_flag=nrf24l01_Tx_Packet(SendBuf);
			if(nrfsend_flag==1)
			{
				printf("Send_OK\n");//ͳɹ
			}
			else if(nrfsend_flag==2)
			{
				printf("Send_max\n");//ʹﵽֵ
			}
			else if(nrfsend_flag==0)
			{
				printf("Send_NO\n");//ԭʧ
			}
		}
	}
}
//ʱʹ
void PeriphClock(void)
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1,ENABLE);
}	
//LEDʼ
void KeyLed_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	//GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);//رjtagʹSWDSWDģʽ
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;//LED0
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_8;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	GPIO_SetBits(GPIOA,GPIO_Pin_8);
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;//KEY0
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_5;
	GPIO_Init(GPIOC,&GPIO_InitStructure);
}
//1ʼ
void usart_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;//LED0
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;//LED0
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	
	USART_InitStructure.USART_BaudRate=9600;
	USART_InitStructure.USART_HardwareFlowControl=USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode=USART_Mode_Rx|USART_Mode_Tx;
	USART_InitStructure.USART_Parity=USART_Parity_No;
	USART_InitStructure.USART_StopBits=USART_StopBits_1;
	USART_InitStructure.USART_WordLength=USART_WordLength_8b;
	USART_Init(USART1,&USART_InitStructure);
	
	USART_Cmd(USART1,ENABLE);
	
	USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);//USARTʹ
	
	NVIC_InitStructure.NVIC_IRQChannel=USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority=1;
	NVIC_Init(&NVIC_InitStructure);
}
//
void key(void)
{
	if(KEY0==0)
	{
		if(key0flag==0)
		{
			delay_ms(5);
			if(KEY0==0)
			{
        key0flag=1;		
				//LEDƽȡ
				printf("KEY_OK\n");
        key_sendflag=1;//ͱ־λλ
				GPIO_WriteBit(GPIOA,GPIO_Pin_8,(BitAction)(1-GPIO_ReadOutputDataBit(GPIOA,GPIO_Pin_8)));				
			}
		}
	}
	else
  {
		key0flag=0;
	}
}
//1жϷ
void USART1_IRQHandler(void)
{
	if(USART_GetITStatus(USART1,USART_IT_RXNE)==SET)
	{
		if(USART_ReceiveData(USART1)=='b')//
		{
			printf("USART_OK");
		}
	}
}
