#include "nrf24l01.h"
#include "delay.h"

//һշ͵ַ 5ֽ
u8 TX_RX_ADDR[]={0xe7,0xe7,0xe7,0xe7,0xe7};

//дһֽڶһֽ
u8 SPI_WriteRead_Byte(u8 wdata)
{
	u8 i=0;
	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_TXE)==RESET)
	{
		i++;
		if(i>210) return 0;
	}
	SPI_I2S_SendData(SPI1,wdata);
	i=0;
	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_RXNE)==RESET)
	{
		i++;
		if(i>210) return 0;
	}
  return SPI_I2S_ReceiveData(SPI1);
}
//SPIʼ
void spi_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	SPI_InitTypeDef SPI_InitStructure;
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;//SCK MOSI
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_5|GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;//MISO 
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	GPIO_SetBits(GPIOA,GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7);//
	
  SPI_InitStructure.SPI_BaudRatePrescaler=SPI_BaudRatePrescaler_8;
	SPI_InitStructure.SPI_CPHA=SPI_CPHA_1Edge;
	SPI_InitStructure.SPI_CPOL=SPI_CPOL_Low;
	SPI_InitStructure.SPI_CRCPolynomial=7;
	SPI_InitStructure.SPI_DataSize=SPI_DataSize_8b;
	SPI_InitStructure.SPI_Direction=SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_FirstBit=SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_Mode=SPI_Mode_Master;//SPI
	SPI_InitStructure.SPI_NSS=SPI_NSS_Soft;//
	
	SPI_Init(SPI1,&SPI_InitStructure);
	SPI_Cmd(SPI1,ENABLE);
	SPI_WriteRead_Byte(0xff);// ??
}
//nrf24l01ʼ
void nrf24l01_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;//
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4;//F_CS SD_CS NRF_CE
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	GPIO_SetBits(GPIOA,GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4);//
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;//
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_4;//NRF_CS
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOC,&GPIO_InitStructure);
	GPIO_SetBits(GPIOC,GPIO_Pin_4);//
	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;//
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_1;//NRF_IRQ
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	GPIO_SetBits(GPIOA,GPIO_Pin_1);//
	
	spi_init();//SPIʼ
	CS_SET;
	CE_CLR;
}
//дָĴ
u8 SPI_Write_Reg(u8 Reg,u8 data)
{
	u8 status;
  CS_CLR;
  status=SPI_WriteRead_Byte(Reg);
	SPI_WriteRead_Byte(data);
  CS_SET;
	return status;
}
//ָĴ
u8 SPI_Read_Reg(u8 Reg)
{
	u8 rdata;
	CS_CLR;
	SPI_WriteRead_Byte(Reg);
	rdata=SPI_WriteRead_Byte(0xff);
	CS_CLR;
	return rdata;
}
//ָĴдָȵ
u8 SPI_Write_Buf(u8 Reg,u8 *buf,u8 leng)
{
	u8 i=0,status=0;
	CS_CLR;
	status=SPI_WriteRead_Byte(Reg);//дַָ
	for(i=0;i<leng;i++) SPI_WriteRead_Byte(*buf++); 
	CS_SET;
	return status;
}
//ָĴָȵ
u8 SPI_Read_Buf(u8 Reg,u8 *buf,u8 leng)
{
	u8 i=0,status=0;
	CS_CLR;
	status=SPI_WriteRead_Byte(Reg);//дַָ
	for(i=0;i<leng;i++) buf[i]=SPI_WriteRead_Byte(0xff);
	CS_SET;
	return status;
}
//óɷģʽ
void NRF24L01_Tx_Mode(void)
{
	CE_CLR;  //ԼĴ Ҫڵʹģʽ
	SPI_Write_Reg(0x20+0x01,0x01);//ͨ0Զʹ
	SPI_Write_Reg(0x20+0x02,0x01);//ͨ0
	SPI_Write_Reg(0x20+0x03,0x03);///͵ַΪ5ֽ
	SPI_Write_Reg(0x20+0x04,0x1a);//Զشʱ500us Զش10
	SPI_Write_Reg(0x20+0x05,0x02);//Ƶͨ
	SPI_Write_Reg(0x20+0x06,0x0f);//1Mbps 0dBm
	
	//SPI_Write_Reg(0x20+0x11,32);//ͨ0RXЧغֽ 32ֽ
	SPI_Write_Reg(0x20+0x11,5);   //ͨ0RXЧغֽ 5ֽ
	
  SPI_Write_Buf(0x20+0x0a,(u8*)TX_RX_ADDR,5);//ͨ0 ַ
	SPI_Write_Buf(0x20+0x10,(u8*)TX_RX_ADDR,5);//дֽ ͵ַֻPTX豸
	//һǿ͵ ַͨ0Ľַܵһ Ӧź
	SPI_Write_Reg(0x20,0x0e);//ϵPW_UP PRIM_RX=0
	CE_SET;                  //ǰΪģʽII  TX_FIFOΪ
}
//óɽģʽ
void NRF24L01_Rx_Mode(void)
{
	CE_CLR;//ֻڵģʽִ
	SPI_Write_Reg(0x20+0x01,0x01);//ͨ0Զʹ
	SPI_Write_Reg(0x20+0x02,0x01);//ͨ0
	SPI_Write_Reg(0x20+0x03,0x03);///͵ַΪ5ֽ
	SPI_Write_Reg(0x20+0x04,0x1a);//Զشʱ500us Զش10
	SPI_Write_Reg(0x20+0x05,0x02);//Ƶͨ 2.4M
	SPI_Write_Reg(0x20+0x06,0x0f);//1Mbps 0dBm
	
	//SPI_Write_Reg(0x20+0x11,32);//ͨ0RXЧغֽ 32ֽ
	SPI_Write_Reg(0x20+0x11,5);   //ͨ0RXЧغֽ 5ֽ
	
  SPI_Write_Buf(0x20+0x0a,(u8*)TX_RX_ADDR,5);//ͨ0 ַ
	SPI_Write_Reg(0x20,0x0f); //ϵPW_UP PRIM_RX=1;
	CE_SET;   //ģʽ 130usʼ
}
//NRF24L01Ƿ-ģʽǰ-ģʽ
u8 nrf24l01_Cheak(void)
{
	u8 i=0;
  u8 buf[]={0x5e,0x5e,0x5e,0x5e,0x5e};//㶨 Ҫһ 
	
	SPI_Write_Buf(0x20+0x0a,buf,5);//ͨ0дַ
	SPI_Read_Buf(0x0a,buf,5);      //ͨ0
	
	for(i=0;i<5;i++)
  {
		if(buf[i]!=0x5e) break;//ѭ
  }	
	if(i!=5) return 0;//ʧ ĵַдĵַȫ
	return 1;//ɹ
}
//--------nrf24l01һݰ---------
u8 nrf24l01_Rx_Packet(u8 *rbuf)
{
	u8 status,rxflag=0;
	status=SPI_Read_Reg(0x07);      //״̬ κ״̬¶Զ״̬
	SPI_Write_Reg(0x20+0x07,status);//жϱ־λ  
	if(status&0x40)                 //жϽձ־λ
	{
		//SPI_Read_Buf(0x61,rbuf,32); // 32Byte ȶֽ
		SPI_Read_Buf(0x61,rbuf,5);    // 5Byte ȶֽ
		
		SPI_Write_Reg(0xe2,0xff); 
		//RX_FIFO ڽģʽ ָʺϷģʽ Ӧвִ
		rxflag=1;                       //ճɹ
		CE_CLR;                         //ģʽ
		SPI_Write_Reg(0x20+0x07,status);//жϱ־λ
	  USART_SendData(USART1,SPI_Read_Reg(0x07));
		CE_SET;                         //ٴνģʽ
   }
	return rxflag;                    //ؽ״̬־λ
}
